]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: Refactor `cdremote`: Use `_list_remotes`
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    has_completion() { return 0; }
75    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
76       if [ "$SHELL" = /bin/bash ]; then
77          if [ -d /usr/share/bash-completion ]; then
78             . /usr/share/bash-completion/bash_completion
79             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
80          elif [ -f /etc/bash_completion ]; then
81             . /etc/bash_completion
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          elif [ -d /etc/bash_completion.d ]; then
84             for _compf in /etc/bash_completion.d/*; do
85                . $_compf
86             done
87             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
88          fi
89       elif [ "$SHELL" = /usr/local/bin/bash ]; then
90          if [ -d /usr/local/etc/bash_completion.d ]; then
91             for _compf in /usr/local/etc/bash_completion.d/*; do
92                . $_compf
93             done
94             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
95          fi
96       else
97          echo "Unknown OS type, cannot source bash_completion" >&2
98       fi
99    fi
100
101    if [ -d "$HOME"/.bash_completion.d ]; then
102       for _compf in "$HOME"/.bash_completion.d/*; do
103          . $_compf
104       done
105    fi
106
107    for cmd in builtin cgmem_nice command dbus-launch exec \
108       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
109       time whence whereis which xargs; do
110          ! has_completion $cmd && complete -o default -A command $cmd
111    done
112
113    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
114       telnet t tt \
115       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
116       whois wget wget-m wget-wrapper ww; do
117          ! has_completion $cmd && complete -A hostname $cmd
118    done
119
120    for cmd in distribute ftp lftp r rsync \
121       s scp ssh smbclient tcpdump tshark wireshark; do
122          ! has_completion $cmd && complete -o default -A hostname $cmd;
123    done
124
125    delegate_completion() {
126       local prog programs
127       prog=$1
128       if has_completion $prog; then
129          shift
130          programs="$@"
131          eval "_${prog}_completion_loader() {
132             _completion_loader $prog
133             complete -F _$prog $programs
134             unset _${prog}_completion_loader
135             return 124
136          }"
137          complete -F _${prog}_completion_loader $programs
138       fi
139    }
140
141    delegate_completion make m
142    delegate_completion ping p
143    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
144    delegate_completion ssh s
145    delegate_completion wget wget-m wget-wrapper ww
146
147    unset has_completion delegate_completion
148
149    complete -A job bg fg j jobs wait
150    complete -A variable -A function unset
151
152    if [ -d "$HOME/lib/config" ]; then
153       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
154    fi
155    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
156
157    #if type -p pip >/dev/null 2>&1; then
158    #   eval "`pip completion --bash`"
159    #   rm -rf /tmp/pip_build_"$USER"
160    #fi
161
162    #if which pyenv >/dev/null 2>&1; then
163    #   eval "`pyenv init -`"
164    #   eval "`pyenv virtualenv-init -`"
165    #fi
166
167    source virtualenvwrapper_lazy.sh 2>/dev/null
168
169    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
170       . "$VIRTUAL_ENV/bin/activate"
171    fi
172
173    # Clean up python virtual environment on exit
174    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
175
176    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
177
178 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
179    back() { cd - "$@"; }
180    j() { jobs; }
181 fi
182
183
184 # clear screen and history, logout
185 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
186
187
188 if test -x /usr/bin/git >/dev/null 2>&1; then
189    # chdir to a directory
190    cdgitpath() {
191       if [ -z "$1" -o -n "$2" ]; then
192          echo "Usage: cdgitpath path_key" >&2
193          return 1
194       else
195          path_key="$1"
196       fi
197
198       if [ -z "$path_key" ]; then
199          echo "Usage: cdgitpath path_key" >&2
200          return 1
201       fi
202
203       cd "`git config --get --path $path_key`"
204    }
205
206    # chdir to a remote's directory (if the remote is on the local FS)
207    cdremote() {
208       if [ -z "$1" ]; then
209          branch="`git rev-parse --abbrev-ref HEAD`"
210          remote="`git config --get branch.$branch.remote`"
211       elif [ -n "$2" ]; then
212          echo "Usage: cdremote [remote_name]" >&2
213          return 1
214       else
215          remote="$1"
216       fi
217
218       if [ -z "$remote" ]; then
219          echo "Cannot find remote for branch $branch" >&2
220          echo "Usage: cdremote [remote_name]" >&2
221          return 1
222       fi
223
224       if git config --get remote.$remote.url | grep -q '^\(/\|\.\./\)'; then
225          cdgitpath remote.$remote.url
226       else
227
228          _list_remotes '^\(/\|\.\./\)' # (/ or ../ at the beginning)
229          if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
230             remote=${GIT_REMOTES[0]}
231             unset GIT_REMOTES
232             cdgitpath remote.$remote.url
233          else
234             unset GIT_REMOTES
235             echo "Cannot find directory for any remote" >&2
236             echo "Usage: cdremote [remote_name]" >&2
237             return 1
238          fi
239       fi
240    }
241
242    if test -n "$BASH_VERSION"; then
243       # completion for aliases in global .gitconfig
244
245       # fixup rbi rbia rbiap rbip - do refs name completion
246       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
247       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
248       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
249       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
250       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
251       #
252       # push-to-all-remotes - do branch name completion
253       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
254
255       _cdgitpath_completion_loader() {
256          _completion_loader git
257          complete -F _cdgitpath_complete cdgitpath git-open
258          unset _cdgitpath_completion_loader
259          return 124
260       }
261
262       _cdgitpath_complete() {
263          local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
264          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
265       }
266
267       _git_open() {
268          _cdgitpath_complete
269       }
270
271       complete -F _cdgitpath_completion_loader cdgitpath git-open
272
273       # list remotes with URLs matching a regexp
274       _list_remotes() {
275          if [ -z "$1" -o -n "$2" ]; then
276             echo "Usage: _list_remotes remote_regexp" >&2
277             return 1
278          fi
279          declare -ag GIT_REMOTES=()
280          local remote
281          for remote in `git remote`; do
282             if git config --get remote.$remote.url | grep -q "$1"; then
283                GIT_REMOTES+=($remote)
284             fi
285          done
286       }
287
288       # completion for cdremote and git-open-remote - list remotes with a pattern
289       _list_remotes_completion() {
290          local cur="${COMP_WORDS[COMP_CWORD]}";
291          _list_remotes "$1"
292          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
293          unset GIT_REMOTES
294       }
295
296       # completion for cdremote - list remotes with directories as URLs
297       _cdremote_complete() {
298          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
299          if [ ${#COMPREPLY[*]} -eq 0 ]; then
300             _list_remotes_completion .
301          fi
302       }
303
304       complete -F _cdremote_complete cdremote
305
306       # completion for git-open-remote - list remotes with http(s) URLs
307       _git_open_remote() {
308          _list_remotes_completion '^http\(s\)\?://'
309          if [ ${#COMPREPLY[*]} -eq 0 ]; then
310             _list_remotes_completion .
311          fi
312       }
313
314       complete -F _git_open_remote git-open-remote
315    fi
316 fi
317
318
319 include() {
320    cfg="$1"
321    if [ -f "./$cfg" -a -r "./$cfg" ]; then
322       echo "Reading config file \`$cfg'" 1>&2
323       . "./$cfg"
324    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
325       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
326       . "$HOME/lib/config/$cfg"
327    else
328       echo "Cannot find config file \`$cfg'" 1>&2
329    fi
330 }
331
332
333 mc() {
334    if test -n "$BASH_VERSION"; then
335       MC_SAVE_OPS1="$OPS1"
336       OPS1="\u@\h "
337    fi
338
339    if [ -n "$SLOWTERM" ]; then
340       MC_SLOW="--slow"
341    fi
342
343    case "$TERM" in
344       screen*) # screen, screen.rxvt
345          MC_XTERM="-x"
346       ;;
347    esac
348
349    #TMPDIR="$HOME"/tmp
350    #export TMPDIR
351
352    MC_FOUND=NO
353
354    for wrapper in \
355          /usr/local/share/mc/bin/mc-wrapper.sh \
356          /usr/local/libexec/mc/mc-wrapper.sh \
357          /usr/share/mc/bin/mc-wrapper.sh; do
358       if [ -r $wrapper ]; then
359          . $wrapper $MC_SLOW $MC_XTERM "$@"
360          rc=$?
361          MC_FOUND=YES
362          break
363       fi
364    done
365
366    if [ $MC_FOUND = NO ]; then
367       for mc in /usr/local/bin/mc /usr/bin/mc; do
368          if [ -x $mc ]; then
369             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
370             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
371                MC_TMP_DIR="${TMPDIR-/tmp}"
372             fi
373             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
374             mc_type="`mc_type.py $mc`"
375             if [ "$mc_type" = old ]; then
376                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
377             elif [ "$mc_type" = new ]; then
378                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
379             else
380                continue
381             fi
382             rc=$?
383             MC_FOUND=YES
384             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
385             break
386          fi
387       done
388    fi
389
390    if [ $MC_FOUND = NO ]; then
391       echo "Cannot find mc-wrapper.sh or mc" >&2
392       rc=1
393    fi
394
395    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
396    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
397
398    return $rc
399 }
400
401
402 mkcd() {
403    if [ $# -ne 1 ]; then
404       echo "Usage: mkcd directory_name" >&2
405    elif [ -d "$1" ]; then
406       cd "$1"
407    elif [ -e "$1" ]; then
408       echo "Error: $1 is a file" >&2
409    else
410       mkdir -p "$1" && cd "$1"
411    fi
412 }
413
414
415 if which tmux >/dev/null 2>&1; then
416    tmux() {
417       case "$TERM" in
418          rxvt)
419             TERM=rxvt-unicode command tmux "$@"
420          ;;
421
422          *)
423             command tmux "$@"
424          ;;
425       esac
426    }
427 fi
428
429
430 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
431    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
432 fi
433
434 x() { exit; }